<?php
// This file is part of Moodle - https://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <https://www.gnu.org/licenses/>.

/**
 * Plugin administration pages are defined here.
 *
 * @package     mod_timetable
 * @category    admin
 * @copyright   2020 Raphael Dannecker <raphael.dannecker@steinbeisschule-reutlingen.de>
 * @license     https://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

defined('MOODLE_INTERNAL') || die();

if ($ADMIN->fulltree) {
   // TODO: Define the plugin settings page.
   // https://docs.moodle.org/dev/Admin_settings
}

$settings->add(new admin_setting_configcheckbox('timetable/saturday',
                                                get_string('labelsaturday', 'mod_timetable'),
                                                get_string('descsaturday', 'mod_timetable'),
                                                '0'));

$settings->add(new admin_setting_configtext('timetable/fname_lesson',
                                             get_string('labelfnamelesson', 'mod_timetable'),
                                             get_string('descfnamelesson', 'mod_timetable'),
                                            ''));

$settings->add(new admin_setting_configtext('timetable/fname_substitution',
                                             get_string('labelfnamesubst', 'mod_timetable'),
                                             get_string('descfnamesubst', 'mod_timetable'),
                                            ''));

$settings->add(new admin_setting_configtext('timetable/fname_absence',
                                             get_string('labelfnameabs', 'mod_timetable'),
                                             get_string('descfnameabs', 'mod_timetable'),
                                            ''));

$settings->add(new admin_setting_configtext('timetable/fname_absence_reason',
                                             get_string('labelfnameabsreas', 'mod_timetable'),
                                             get_string('descfnameabsreas', 'mod_timetable'),
                                            ''));

$settings->add(new admin_setting_configtext('timetable/fname_teacher',
                                             get_string('labelfnameteacher', 'mod_timetable'),
                                             get_string('descfnameteacher', 'mod_timetable'),
                                            ''));

$settings->add(new admin_setting_configtext('timetable/fname_class',
                                             get_string('labelfnameclass', 'mod_timetable'),
                                             get_string('descfnameclass', 'mod_timetable'),
                                             ''));

$settings->add(new admin_setting_configtext('timetable/fname_room',
                                             get_string('labelfnameroom', 'mod_timetable'),
                                             get_string('descfnamesroom', 'mod_timetable'),
                                            ''));

$settings->add(new admin_setting_configtext('timetable/fname_times',
                                             get_string('labelfnametimes', 'mod_timetable'),
                                             get_string('descfnametimes', 'mod_timetable'),
                                            ''));

$settings->add(new admin_setting_configtext('timetable/numperiod',
                                             get_string('labelnumperiod', 'mod_timetable'),
                                             get_string('descnumperiod', 'mod_timetable'),
                                            12, PARAM_INT));
